package com.gree.mall.miniapp.logic.material.parts;

import cn.hutool.core.bean.BeanUtil;
import com.gree.mall.miniapp.bean.material.WebsitPartsSalesBean;
import com.gree.mall.miniapp.bean.material.WebsitPartsSalesItemBean;
import com.gree.mall.miniapp.enums.material.PartsOrderStatusEnum;
import com.gree.mall.miniapp.enums.material.PartsPayFlagEnum;
import com.gree.mall.miniapp.plus.entity.WebsitPartsSales;
import com.gree.mall.miniapp.plus.entity.WebsitPartsSalesItem;
import com.gree.mall.miniapp.plus.entity.WebsitSalesPayOrder;
import com.gree.mall.miniapp.plus.service.WebsitPartsSalesItemService;
import com.gree.mall.miniapp.plus.service.WebsitPartsSalesService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
@Slf4j
public class WebsitPartsSalesOrderLogic {

    @Resource
    WebsitPartsSalesService websitPartsSalesService;
    @Resource
    WebsitPartsSalesItemService websitPartsSalesItemService;

    public void handlePaySuccessMethod(WebsitSalesPayOrder order) {
        // 更新配件销售单状态为已支付
        WebsitPartsSales partsSalesOrder = websitPartsSalesService.lambdaQuery()
                .eq(WebsitPartsSales::getId, order.getOrderId())
                .one();

        log.info("配件销售单状态：" + partsSalesOrder.getStatus());
        if (PartsOrderStatusEnum.SUBMIT.getKey().equals(partsSalesOrder.getStatus())) {
            // 销售单状态是提交状态执行
            partsSalesOrder.setPayType(order.getPayType())
                    .setPayFlag(PartsPayFlagEnum.PAY_NOT_TAKE.getKey())
                    .setStatus(PartsOrderStatusEnum.PAYED.getKey())
                    .setPayTime(order.getPayTime())
                    .setTransactionId(order.getTransactionId())
                    .setOpenid(order.getOpenid());


            List<WebsitPartsSalesItem> partsSalesOrderItems = websitPartsSalesItemService.lambdaQuery()
                    .eq(WebsitPartsSalesItem::getSalesId, order.getOrderId())
                    .list();

            if (!partsSalesOrder.getIsApply()) {
                WebsitPartsSalesBean partsSalesOrderBean = new WebsitPartsSalesBean();
                BeanUtils.copyProperties(partsSalesOrder, partsSalesOrderBean);
                List<WebsitPartsSalesItemBean> partsSalesOrderItemBeanList = BeanUtil.copyToList(partsSalesOrderItems, WebsitPartsSalesItemBean.class);

                partsSalesOrderBean.setItemList(partsSalesOrderItemBeanList);
// TODO 补充逻辑
//                this.handleForwardShopAndWorkerStock(partsSalesOrderBean);
            }

            partsSalesOrder.updateById();
        }
    }
}
